package cz.muni.fi.pb162.hw03.csv.impl;

import cz.muni.fi.pb162.hw03.csv.CsvReader;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.nio.charset.Charset;
import java.util.Arrays;
import java.util.List;
import java.util.function.Consumer;
import java.util.stream.Collectors;

import static cz.muni.fi.pb162.hw03.csv.Messages.INVALID_FORMAT;

public class Reader implements CsvReader<List<String>> {
    private final BufferedReader reader;
    private final String delimiter;
    public Reader(InputStream is, Charset charset, String delimiter){
        reader = new BufferedReader(new InputStreamReader(is,charset));
        this.delimiter = delimiter;
    }


    @Override
    public void forEach(Consumer consumer) throws IOException {
        while (reader.ready()){
            consumer.accept(read());
        }
    }

    @Override
    public void close() throws IOException {
        reader.close();
    }

    @Override
    public List<String> read() throws IOException {
        return reader.ready() ? Arrays.asList(reader.readLine().split(delimiter))
                .stream()
                .map(String::trim)
                .collect(Collectors.toList()) :null;
    }
}
